Attribute VB_Name = "basCommon"
Option Explicit

'Private Declare Function MultiByteToWideChar Lib "kernel32" ( _
'    ByVal CodePage As Long, _
'    ByVal dwFlags As Long, _
'    ByVal lpMultiByteStr As String, _
'    ByVal cchMultiByte As Long, _
'    ByVal lpWideCharStr As String, _
'    ByVal cchWideChar As Long _
') As Long
Private Declare Function MultiByteToWideChar Lib "kernel32" ( _
    ByVal CodePage As Long, _
    ByVal dwFlags As Long, _
    ByVal lpMultiByteStr As Long, _
    ByVal cchMultiByte As Long, _
    ByVal lpWideCharStr As Long, _
    ByVal cchWideChar As Long _
) As Long

'Private Declare Function WideCharToMultiByte Lib "kernel32" ( _
'    ByVal CodePage As Long, _
'    ByVal dwFlags As Long, _
'    ByVal lpWideCharStr As String, _
'    ByVal cchWideChar As Long, _
'    ByVal lpMultiByteStr As String, _
'    ByVal cchMultiByte As Long, _
'    ByVal lpDefaultChar As String, _
'    ByVal lpUsedDefaultChar As Long _
') As Long
Private Declare Function WideCharToMultiByte Lib "kernel32" ( _
    ByVal CodePage As Long, _
    ByVal dwFlags As Long, _
    ByVal lpWideCharStr As Long, _
    ByVal cchWideChar As Long, _
    ByVal lpMultiByteStr As Long, _
    ByVal cchMultiByte As Long, _
    ByVal lpDefaultChar As Long, _
    ByVal lpUsedDefaultChar As Long _
) As Long

Public Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    ByRef Destination As Any, _
    ByRef Source As Any, _
    ByVal Length As Long _
)

Private Const CP_ACP As Long = 0
Private Const CP_UTF8 As Long = 65001

Public Function UTF8toUTF16(ByVal lngpUTF8 As Long, Optional ByVal lngLen As Long = -1) As String
    Dim lngNum As Long
    UTF8toUTF16 = ""
    
    lngNum = MultiByteToWideChar(CP_UTF8, 0, lngpUTF8, lngLen, 0, 0)
    'Debug.Print "MultiByteToWideChar", lngNum
    If lngLen = -1 Then lngNum = lngNum - 1 'I[O
    
    If lngNum > 0 Then
        UTF8toUTF16 = String(lngNum, vbNullChar)
        
        lngNum = MultiByteToWideChar(CP_UTF8, 0, lngpUTF8, lngLen, StrPtr(UTF8toUTF16), lngNum)
        'Debug.Print "MultiByteToWideChar", UTF8toUTF16withLen
    End If
End Function

Public Function ShiftJIStoUTF16(ByVal lngpShiftJIS As Long, Optional ByVal lngLen As Long = -1) As String
    Dim lngNum As Long
    ShiftJIStoUTF16 = ""
    
    lngNum = MultiByteToWideChar(CP_ACP, 0, lngpShiftJIS, lngLen, 0, 0)
    'Debug.Print "MultiByteToWideChar", lngNum
    If lngLen = -1 Then lngNum = lngNum - 1 'I[O
    
    If lngNum > 0 Then
        ShiftJIStoUTF16 = String(lngNum, vbNullChar)
        
        lngNum = MultiByteToWideChar(CP_ACP, 0, lngpShiftJIS, lngLen, StrPtr(ShiftJIStoUTF16), lngNum)
        'Debug.Print "MultiByteToWideChar", ShiftJIStoUTF16
    End If
End Function

Public Function UTF16toUTF8(ByRef strUTF16 As String, ByRef bytUTF8() As Byte) As Long
    Dim lngNum As Long
    Dim lngCnt As Long
    Dim strWk As String
    ReDim bytUTF8(0)
    bytUTF8(0) = 0
    
    If Len(strUTF16) > 0 Then
        lngNum = WideCharToMultiByte(CP_UTF8, 0, StrPtr(strUTF16), Len(strUTF16), 0, 0, 0, 0)
        'Debug.Print "WideCharToMultiByte", lngNum
        
        If lngNum > 0 Then
            ReDim bytUTF8(lngNum) 'I[܂
            
            lngNum = WideCharToMultiByte(CP_UTF8, 0, StrPtr(strUTF16), Len(strUTF16), VarPtr(bytUTF8(0)), lngNum, 0, 0)
            bytUTF8(lngNum) = 0 'I[
            'strWk = ""
            'For lngCnt = 0 To lngNum - 1
            '    strWk = strWk & Hex$(bytUTF8(lngCnt)) & " "
            'Next
            'Debug.Print "WideCharToMultiByte", strWk
        End If
    End If
    
    UTF16toUTF8 = VarPtr(bytUTF8(0))
End Function

Public Function getBLOB(ByVal lngAdrs As Long, ByVal lngNum As Long) As String
    Dim lngCnt As Long
    Dim bytBLOB() As Byte
    ReDim bytBLOB(lngNum - 1)
    
    Call MoveMemory(bytBLOB(0), ByVal lngAdrs, lngNum)
    
    getBLOB = ""
    For lngCnt = 0 To lngNum - 1
        getBLOB = getBLOB & Hex$(bytBLOB(lngCnt)) & " "
    Next
    
End Function


