Attribute VB_Name = "basUserFunc2"
Option Explicit

Private Const USERFUNC2_PATH As String = ":memory:" 'C

Private Type typAggregate
    lngDataNum As Long
    lngLow As Long
    lngHigh As Long
End Type


Private Sub func_kakusa_step(ByVal lngpCtx As Long, ByVal lngArgNum As Long, ByVal lngppValue As Long)
    Dim lngCallCnt As Long
    Dim lngCallCntAdrs As Long
    Dim lngpValue() As Long
    Dim lngOndo As Long
    Dim lngAggregateAdrs As Long
    Dim udtAggregate As typAggregate
    
    'R[񐔉Z
    lngCallCntAdrs = sqlite3std_user_data(lngpCtx)
    Call MoveMemory(lngCallCnt, ByVal lngCallCntAdrs, 4)
    lngCallCnt = lngCallCnt + 1
    Call MoveMemory(ByVal lngCallCntAdrs, lngCallCnt, 4)
    
    '擾
    ReDim lngpValue(lngArgNum - 1)
    Call MoveMemory(lngpValue(0), ByVal lngppValue, lngArgNum * 4)
    
    lngOndo = sqlite3std_value_int(lngpValue(0))
    
    'W
    lngAggregateAdrs = sqlite3std_aggregate_context(lngpCtx, Len(udtAggregate))
    
    Call MoveMemory(udtAggregate, ByVal lngAggregateAdrs, Len(udtAggregate))
    
    With udtAggregate
        If lngCallCnt = 1 Then 'O[v̍ŏ̃f[^
            .lngDataNum = 1
            .lngLow = lngOndo
            .lngHigh = lngOndo
        Else
            .lngDataNum = .lngDataNum + 1
            If lngOndo < .lngLow Then .lngLow = lngOndo
            If lngOndo > .lngHigh Then .lngHigh = lngOndo
        End If
    End With
    
    Call MoveMemory(ByVal lngAggregateAdrs, udtAggregate, Len(udtAggregate))
    
    Debug.Print "func_kakusa_step#" & CStr(lngCallCnt), lngOndo
    
End Sub

Private Sub func_kakusa_final(ByVal lngpCtx As Long)
    Dim lngCallCnt(1) As Long
    Dim lngCallCntAdrs As Long
    Dim lngKakusa As Long
    Dim lngAggregateAdrs As Long
    Dim udtAggregate As typAggregate
    
    'R[񐔉ZAstep̃R[񐔂Zbg
    lngCallCntAdrs = sqlite3std_user_data(lngpCtx)
    Call MoveMemory(lngCallCnt(0), ByVal lngCallCntAdrs, 8)
    lngCallCnt(0) = 0 'step
    lngCallCnt(1) = lngCallCnt(1) + 1 'final
    Call MoveMemory(ByVal lngCallCntAdrs, lngCallCnt(0), 8)
    
    'xrvZ
    lngAggregateAdrs = sqlite3std_aggregate_context(lngpCtx, Len(udtAggregate))
    
    Call MoveMemory(udtAggregate, ByVal lngAggregateAdrs, Len(udtAggregate))
    
    With udtAggregate
        lngKakusa = .lngHigh - .lngLow
        Debug.Print "func_kakusa_final#" & CStr(lngCallCnt(1)), "f[^" & CStr(.lngDataNum), _
        "ō" & CStr(.lngHigh), "Œ" & CStr(.lngLow), "r" & CStr(lngKakusa)
    End With
    
    Call MoveMemory(ByVal lngAggregateAdrs, udtAggregate, Len(udtAggregate))
    
    Call sqlite3std_result_int(lngpCtx, lngKakusa)
    
End Sub

Private Function exec_callback(ByRef lngArg As Long, ByVal lngColNum As Long, ByVal lngppCol As Long, ByVal lngppName As Long) As Long
    Dim lngCnt As Long
    Dim lngpCol() As Long
    Dim lngpName() As Long
    
    'Jƒl擾
    ReDim lngpCol(lngColNum - 1)
    ReDim lngpName(lngColNum - 1)
    Call MoveMemory(lngpCol(0), ByVal lngppCol, lngColNum * 4)
    Call MoveMemory(lngpName(0), ByVal lngppName, lngColNum * 4)
    
    'R[񐔉Z
    lngArg = lngArg + 1
    Debug.Print "exec_callback#" & CStr(lngArg)
    
    For lngCnt = 0 To lngColNum - 1
        Debug.Print UTF8toUTF16(lngpName(lngCnt)) & "=" & UTF8toUTF16(lngpCol(lngCnt))
    Next
    
    exec_callback = SQLITE_OK
End Function

Public Sub sampleUserFunc2()
    Dim lngRtnCd As Long
    Dim lngDB As Long
    Dim lngCnt As Long
    Dim lngArg As Long 'exec_callbackR[
    Dim lngCallCnt(1) As Long 'func_kakusa_step,func_kakusa_finalR[
    Dim bytSQL() As Byte
    Dim strSQL(8) As String
    strSQL(0) = "DROP TABLE IF EXISTS kisyou;"
    strSQL(1) = "CREATE TABLE kisyou ( machi TEXT, ondo INTEGER );"
    strSQL(2) = "INSERT INTO kisyou ( machi, ondo ) VALUES ( 'tokyo', 7 );"
    strSQL(3) = "INSERT INTO kisyou ( machi, ondo ) VALUES ( 'osaka', 5 );"
    strSQL(4) = "INSERT INTO kisyou ( machi, ondo ) VALUES ( 'tokyo', 3 );"
    strSQL(5) = "INSERT INTO kisyou ( machi, ondo ) VALUES ( 'osaka', 12 );"
    strSQL(6) = "INSERT INTO kisyou ( machi, ondo ) VALUES ( 'tokyo', 11 );"
    strSQL(7) = "INSERT INTO kisyou ( machi, ondo ) VALUES ( 'osaka', 2 );"
    strSQL(8) = "INSERT INTO kisyou ( machi, ondo ) VALUES ( 'tokyo', 8 );"
    Const SQLSELECT As String = "SELECT machi, kakusa(ondo) FROM kisyou GROUP BY machi;"
    lngDB = 0
    lngArg = 0
    lngCallCnt(0) = 0
    lngCallCnt(1) = 0
    
    'I[v
    lngRtnCd = sqlite3std_open_v2(USERFUNC2_PATH, lngDB, SQLITE_OPEN_CREATE Or SQLITE_OPEN_READWRITE, vbNullString)
    Debug.Print "sqlite3std_open_v2", lngRtnCd, lngDB
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "open sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_exit
    End If

    'e[u폜Ae[u쐬Af[^ǉ
    For lngCnt = 0 To UBound(strSQL)
        lngRtnCd = sqlite3std_exec_UTF8(lngDB, UTF16toUTF8(strSQL(lngCnt), bytSQL), 0, ByVal 0, ByVal 0)
        Debug.Print "sqlite3std_exec#" & CStr(lngCnt), lngRtnCd
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
    Next
    
    '[U[֐쐬
    lngRtnCd = sqlite3std_create_function(lngDB, "kakusa", 1, SQLITE_UTF8, lngCallCnt(0), 0, _
        AddressOf func_kakusa_step, AddressOf func_kakusa_final)
    Debug.Print "sqlite3std_create_function", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "create_function sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    '
    lngRtnCd = sqlite3std_exec(lngDB, SQLSELECT, AddressOf exec_callback, lngArg, ByVal 0)
    Debug.Print "SQLSELECT sqlite3std_exec", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
lbl_close:
    If lngDB <> 0 Then Call sqlite3std_close(lngDB)
lbl_exit:
End Sub


