Attribute VB_Name = "basGetTable"
Option Explicit
Private Const GET_TABLE_PATH As String = ":memory:" 'C

Public Sub sampleGetTable()
    Dim lngRtnCd As Long
    Dim lngDB As Long
    Dim lngResult As Long
    Dim lngRow As Long
    Dim lngColumn As Long
    Dim lngErrmsg As Long
    Dim lngpCol() As Long
    Dim lngCnt As Long
    Dim lngCnt2 As Long
    Dim strSQL(4) As String
    strSQL(0) = "DROP TABLE IF EXISTS sample;"
    strSQL(1) = "CREATE TABLE sample ( txtval TEXT, ival INTEGER, rval REAL );"
    strSQL(2) = "INSERT INTO sample ( txtval, ival, rval ) VALUES ( 'abcde', 123, 456.789 );"
    strSQL(3) = "INSERT INTO sample ( txtval, ival, rval ) VALUES ( 'fghij', 456, 789.123 );"
    strSQL(4) = "INSERT INTO sample ( txtval, ival, rval ) VALUES ( 'klmno', 789, 123.456 );"
    Const SQL_SELECT As String = "SELECT * FROM sample;"
    lngDB = 0
    lngResult = 0
    lngErrmsg = 0
    
    'I[v
    lngRtnCd = sqlite3std_open_v2(GET_TABLE_PATH, lngDB, SQLITE_OPEN_CREATE Or SQLITE_OPEN_READWRITE, vbNullString)
    Debug.Print "sqlite3std_open_v2", lngRtnCd, lngDB
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "open sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_exit
    End If

    'e[u폜Ae[u쐬Af[^ǉ
    For lngCnt = 0 To UBound(strSQL)
        lngRtnCd = sqlite3std_exec(lngDB, strSQL(lngCnt), 0, ByVal 0, ByVal 0)
        Debug.Print "sqlite3std_exec#" & CStr(lngCnt), lngRtnCd
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
    Next
    
    '
    lngRtnCd = sqlite3std_get_table(lngDB, SQL_SELECT, lngResult, lngRow, lngColumn, lngErrmsg)
    Debug.Print "sqlite3std_get_table", lngRtnCd, lngResult, lngRow, lngColumn, lngErrmsg
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "get_table sqlite3std_errcode", sqlite3std_errcode(lngDB)
        GoTo lbl_close
    End If
    
    'ʏo
    ReDim lngpCol((lngRow + 1) * lngColumn - 1)
    Call MoveMemory(lngpCol(0), ByVal lngResult, (lngRow + 1) * lngColumn * 4)
    For lngCnt = 0 To lngRow
        Debug.Print "row#" & CStr(lngCnt), UTF8toUTF16(lngpCol(lngCnt * lngColumn + 0)), _
            UTF8toUTF16(lngpCol(lngCnt * lngColumn + 1)), _
            UTF8toUTF16(lngpCol(lngCnt * lngColumn + 2))
    Next
    
lbl_close:
    If lngErrmsg <> 0 Then Call sqlite3std_free(lngErrmsg)
    If lngResult <> 0 Then Call sqlite3std_free_table(lngResult)
    If lngDB <> 0 Then Call sqlite3std_close(lngDB)
lbl_exit:
End Sub

