Attribute VB_Name = "basUserFunc1"
Option Explicit

Private Const USERFUNC1_PATH As String = ":memory:" 'C

Private bytResult() As Byte 'func_vbformatISQLiteQƂ

Private Sub func_vbformat(ByVal lngpCtx As Long, ByVal lngArgNum As Long, ByVal lngppValue As Long)
    Dim lngCallCnt As Long
    Dim lngCallCntAdrs As Long
    Dim lngpValue() As Long
    Dim lngKingaku As Long
    Dim strKingaku As String
    Dim strFormat As String
    Dim strResult As String
    
    'R[񐔉Z
    lngCallCntAdrs = sqlite3std_user_data(lngpCtx)
    Call MoveMemory(lngCallCnt, ByVal lngCallCntAdrs, 4)
    lngCallCnt = lngCallCnt + 1
    Call MoveMemory(ByVal lngCallCntAdrs, lngCallCnt, 4)
    
    '擾
    ReDim lngpValue(lngArgNum - 1)
    Call MoveMemory(lngpValue(0), ByVal lngppValue, lngArgNum * 4)
    
    lngKingaku = sqlite3std_value_int(lngpValue(0))
    strFormat = UTF8toUTF16(sqlite3std_value_text(lngpValue(1)))
    
    'VBFormat$֐ɂҏW
    strResult = Format$(lngKingaku, strFormat)
    Debug.Print "func_vbformat#" & CStr(lngCallCnt), lngKingaku, strFormat, strResult
    
    Call sqlite3std_result_text_UTF8(lngpCtx, UTF16toUTF8(strResult, bytResult), -1, 0)
    
End Sub

Private Function exec_callback(ByRef lngArg As Long, ByVal lngColNum As Long, ByVal lngppCol As Long, ByVal lngppName As Long) As Long
    Dim lngCnt As Long
    Dim lngpCol() As Long
    Dim lngpName() As Long
    
    'Jƒl擾
    ReDim lngpCol(lngColNum - 1)
    ReDim lngpName(lngColNum - 1)
    Call MoveMemory(lngpCol(0), ByVal lngppCol, lngColNum * 4)
    Call MoveMemory(lngpName(0), ByVal lngppName, lngColNum * 4)
    
    'R[񐔉Z
    lngArg = lngArg + 1
    Debug.Print "exec_callback#" & CStr(lngArg)
    
    For lngCnt = 0 To lngColNum - 1
        Debug.Print UTF8toUTF16(lngpName(lngCnt)) & "=" & UTF8toUTF16(lngpCol(lngCnt))
    Next
    
    exec_callback = SQLITE_OK
End Function

Public Sub sampleUserFunc1()
    Dim lngRtnCd As Long
    Dim lngDB As Long
    Dim lngCnt As Long
    Dim lngArg As Long
    Dim lngVBFormatCnt As Long
    Dim bytSQL() As Byte
    Dim strSQL(3) As String
    strSQL(0) = "DROP TABLE IF EXISTS uriage;"
    strSQL(1) = "CREATE TABLE uriage ( kingaku INTEGER );"
    strSQL(2) = "INSERT INTO uriage ( kingaku ) VALUES ( 12345 );"
    strSQL(3) = "INSERT INTO uriage ( kingaku ) VALUES ( 67890 );"
    Const SQLSELECT As String = "SELECT vbformat(kingaku, '\\###,###') FROM uriage;"
    lngDB = 0
    lngArg = 0
    lngVBFormatCnt = 0
    
    'I[v
    lngRtnCd = sqlite3std_open_v2(USERFUNC1_PATH, lngDB, SQLITE_OPEN_CREATE Or SQLITE_OPEN_READWRITE, vbNullString)
    Debug.Print "sqlite3std_open_v2", lngRtnCd, lngDB
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "open sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_exit
    End If

    'e[u폜Ae[u쐬Af[^ǉ
    For lngCnt = 0 To UBound(strSQL)
        lngRtnCd = sqlite3std_exec_UTF8(lngDB, UTF16toUTF8(strSQL(lngCnt), bytSQL), 0, ByVal 0, ByVal 0)
        Debug.Print "sqlite3std_exec#" & CStr(lngCnt), lngRtnCd
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
    Next
    
    '[U[֐쐬
    lngRtnCd = sqlite3std_create_function(lngDB, "vbformat", 2, SQLITE_UTF8, lngVBFormatCnt, AddressOf func_vbformat, 0, 0)
    Debug.Print "sqlite3std_create_function", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "create_function sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    '
    lngRtnCd = sqlite3std_exec(lngDB, SQLSELECT, AddressOf exec_callback, lngArg, ByVal 0)
    Debug.Print "SQLSELECT sqlite3std_exec", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
lbl_close:
    If lngDB <> 0 Then Call sqlite3std_close(lngDB)
lbl_exit:
End Sub

